<template lang="pug">
div.text-left
  apollo-query(
    ref="follows"
    fetchPolicy="network-only"
    :query="$options.listInstanceFollowsGql"
    #default="{ result: { loading, error, data }, isLoading, query }"
  )
    .empty(v-if="!isLoading && data && data.follows && data.follows.totalCount === 0" style="background-color: transparent;")
      p.empty-subtitle This OLKi server is not following anybody. Only local corpora will be shown.
    div(v-else)
      .text-subtitle.text-gray.
        List of servers followed by this OLKi server. Their content will be shown alongside local content.

      table.table.table-striped.table-hover(v-if="data && data.follows && data.follows.edges.length > 0")
        thead
          tr
            th instance
            th # of corpora
            th since
        tbody
          tr(v-for="instance in data.follows.edges.map(e => e.node)")
            td
              a(:href="instance.target.fullUsername.split('@')[1]") {{ instance.target.fullUsername.split('@')[1] }}
            td {{ instance.count }}
            td.d-flex(style="align-items: center;")
              | {{ formatDate(instance.modificationDate) }}
              apollo-mutation.c-hand.col-ml-auto.mr-2(
                v-if="forAdmin"
                :mutation="$options.deleteFollowGql"
                :variables=`{
                  pk: instance.pk
                }`
                :refetchQueries="(mutationResult) => [{ query: $options.listInstanceFollowsGql }]"
                @error="(errorObject) => $toast.error(`Error trying to delete the follow`, {icon: 'warning'})"
              )
                template(v-slot="{ mutate, loading, error }")
                  md-button.md-icon-button.md-hyperdense(
                    title="Delete follow"
                    @click="mutate()"
                  )
                    i.material-icons(tabindex="-1" style="font-size:1rem;") delete
</template>

<script>
import listInstanceFollowsGql from '~/apollo/queries/listInstanceFollows'
import deleteFollowGql from '~/apollo/mutations/deleteFollow'

export default {
  listInstanceFollowsGql,
  deleteFollowGql,

  props: {
    forAdmin: {
      type: Boolean,
      default: false
    }
  },
  methods: {
    formatDate(date) {
      const d = new Date(date)
      let month = '' + (d.getMonth() + 1)
      let day = '' + d.getDate()
      const year = d.getFullYear()

      if (month.length < 2) month = '0' + month
      if (day.length < 2) day = '0' + day

      return [year, month, day].join('-')
    }
  }
}
</script>

<style scoped>
tbody {
  max-height: 500px;
  overflow-y: scroll;
}
</style>
